diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/wireless/wifi-rate-adaptation-distance.cc ns-3.39/examples/wireless/wifi-rate-adaptation-distance.cc
--- ns-3.38/examples/wireless/wifi-rate-adaptation-distance.cc	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/examples/wireless/wifi-rate-adaptation-distance.cc	2023-07-05 14:23:47.669427000 -0700
@@ -56,6 +56,7 @@
 #include "ns3/boolean.h"
 #include "ns3/command-line.h"
 #include "ns3/config.h"
+#include "ns3/double.h"
 #include "ns3/gnuplot.h"
 #include "ns3/internet-stack-helper.h"
 #include "ns3/ipv4-address-helper.h"
@@ -65,6 +66,7 @@
 #include "ns3/on-off-helper.h"
 #include "ns3/packet-sink-helper.h"
 #include "ns3/ssid.h"
+#include "ns3/string.h"
 #include "ns3/uinteger.h"
 #include "ns3/yans-wifi-channel.h"
 #include "ns3/yans-wifi-helper.h"
@@ -168,10 +170,16 @@
     return m_output;
 }
 
+/**
+ * Callback for 'Rate' trace source
+ *
+ * \param oldRate old MCS rate (bits/sec)
+ * \param newRate new MCS rate (bits/sec)
+ */
 void
-RateCallback(std::string path, uint64_t rate, Mac48Address dest)
+RateCallback(uint64_t oldRate, uint64_t newRate)
 {
-    NS_LOG_INFO((Simulator::Now()).GetSeconds() << " " << dest << " Rate " << rate / 1000000.0);
+    NS_LOG_INFO("Rate " << newRate / 1000000.0 << " Mbps");
 }
 
 int
@@ -194,9 +202,9 @@
     int stepsTime = 1;
 
     CommandLine cmd(__FILE__);
-    cmd.AddValue("staManager", "PRC Manager of the STA", staManager);
-    cmd.AddValue("apManager", "PRC Manager of the AP", apManager);
-    cmd.AddValue("standard", "Wifi Phy Standard", standard);
+    cmd.AddValue("staManager", "Rate adaptation manager of the STA", staManager);
+    cmd.AddValue("apManager", "Rate adaptation manager of the AP", apManager);
+    cmd.AddValue("standard", "Wifi standard (a/b/g/n/ac only)", standard);
     cmd.AddValue("shortGuardInterval",
                  "Enable Short Guard Interval in all stations",
                  shortGuardInterval);
@@ -215,6 +223,12 @@
 
     int simuTime = steps * stepsTime;
 
+    if (standard != "802.11a" && standard != "802.11b" && standard != "802.11g" &&
+        standard == "802.11n-2.4GHz" && standard != "802.11n-5GHz" && standard != "802.11ac")
+    {
+        NS_FATAL_ERROR("Standard " << standard << " is not supported by this program");
+    }
+
     // Define the APs
     NodeContainer wifiApNodes;
     wifiApNodes.Create(1);
@@ -226,6 +240,30 @@
     YansWifiPhyHelper wifiPhy;
     YansWifiChannelHelper wifiChannel = YansWifiChannelHelper::Default();
     wifiPhy.SetChannel(wifiChannel.Create());
+    // Channel configuration via ChannelSettings attribute can be performed here
+    std::string frequencyBand;
+    if (standard == "802.11b" || standard == "802.11g" || standard == "802.11n-2.4GHz")
+    {
+        frequencyBand = "BAND_2_4GHZ";
+    }
+    else
+    {
+        frequencyBand = "BAND_5GHZ";
+    }
+    wifiPhy.Set("ChannelSettings",
+                StringValue("{0, " + std::to_string(chWidth) + ", " + frequencyBand + ", 0}"));
+
+    // By default, the CCA sensitivity is -82 dBm, meaning if the RSS is
+    // below this value, the receiver will reject the Wi-Fi frame.
+    // However, we want to allow the rate adaptation to work down to low
+    // SNR values.  To allow this, we need to do three things:  1) disable
+    // the noise figure (set it to 0 dB) so that the noise level in 20 MHz
+    // is around -101 dBm, 2) lower the CCA sensitivity to a value that
+    // disables it (e.g. -110 dBm), and 3) disable the Wi-Fi preamble
+    // detection model.
+    wifiPhy.Set("CcaSensitivity", DoubleValue(-110));
+    wifiPhy.Set("RxNoiseFigure", DoubleValue(0));
+    wifiPhy.DisablePreambleDetectionModel();
 
     NetDeviceContainer wifiApDevices;
     NetDeviceContainer wifiStaDevices;
@@ -296,10 +334,6 @@
     wifiDevices.Add(wifiStaDevices);
     wifiDevices.Add(wifiApDevices);
 
-    // Set channel width
-    Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/ChannelWidth",
-                UintegerValue(chWidth));
-
     // Set guard interval
     Config::Set(
         "/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/ShortGuardIntervalSupported",
@@ -359,9 +393,9 @@
                     MakeCallback(&NodeStatistics::RxCallback, &atpCounter));
 
     // Callbacks to print every change of rate
-    Config::ConnectFailSafe("/NodeList/0/DeviceList/*/$ns3::WifiNetDevice/RemoteStationManager/$" +
-                                apManager + "/RateChange",
-                            MakeCallback(RateCallback));
+    Config::ConnectWithoutContextFailSafe(
+        "/NodeList/0/DeviceList/*/$ns3::WifiNetDevice/RemoteStationManager/$" + apManager + "/Rate",
+        MakeCallback(RateCallback));
 
     Simulator::Stop(Seconds(simuTime));
     Simulator::Run();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/wireless/wifi-simple-adhoc-grid.cc ns-3.39/examples/wireless/wifi-simple-adhoc-grid.cc
--- ns-3.38/examples/wireless/wifi-simple-adhoc-grid.cc	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/examples/wireless/wifi-simple-adhoc-grid.cc	2023-07-05 14:23:47.669427000 -0700
@@ -255,7 +255,7 @@
     InetSocketAddress remote = InetSocketAddress(i.GetAddress(sinkNode, 0), 80);
     source->Connect(remote);
 
-    if (tracing == true)
+    if (tracing)
     {
         AsciiTraceHelper ascii;
         wifiPhy.EnableAsciiAll(ascii.CreateFileStream("wifi-simple-adhoc-grid.tr"));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/wireless/wifi-vht-network.cc ns-3.39/examples/wireless/wifi-vht-network.cc
--- ns-3.38/examples/wireless/wifi-vht-network.cc	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/examples/wireless/wifi-vht-network.cc	2023-07-05 14:23:47.669427000 -0700
@@ -90,11 +90,8 @@
         Config::SetDefault("ns3::WifiRemoteStationManager::RtsCtsThreshold", StringValue("0"));
     }
 
-    double prevThroughput[8];
-    for (uint32_t l = 0; l < 8; l++)
-    {
-        prevThroughput[l] = 0;
-    }
+    double prevThroughput[8] = {0};
+
     std::cout << "MCS value"
               << "\t\t"
               << "Channel width"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/ns3 ns-3.39/ns3
--- ns-3.38/ns3	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/ns3	2023-07-05 14:23:47.673426900 -0700
@@ -186,8 +186,7 @@
                                   action="store_true", default=None)
 
     parser_configure.add_argument('--out', '--output-directory',
-                                  help=('Use BRITE integration support, given by the indicated path,'
-                                        ' to allow the use of the BRITE topology generator'),
+                                  help=('Directory to store build artifacts'),
                                   type=str, default=None, dest="output_directory")
     parser_configure.add_argument('--with-brite',
                                   help=('Use BRITE integration support, given by the indicated path,'
@@ -282,7 +281,7 @@
                                         help='Try "./ns3 docs --help" for more documentation options')
     parser_docs.add_argument('docs',
                              help='Build project documentation',
-                             choices=["manual", "models", "tutorial", "contributing",
+                             choices=["contributing", "installation", "manual", "models", "tutorial",
                                       "sphinx", "doxygen-no-build", "doxygen", "all"],
                              action="store", type=str, default=None)
 
@@ -610,6 +609,14 @@
         if args.G is None:
             args.G = current_cmake_generator
 
+        # Get the current Python information to supply
+        # CMake with the respective installation
+        if args.enable_python_bindings is True:
+            import sysconfig
+            cmake_args.append(f"-DPython3_LIBRARY_DIRS={sysconfig.get_config_var('LIBDIR')}")
+            cmake_args.append(f"-DPython3_INCLUDE_DIRS={sysconfig.get_config_var('INCLUDEPY')}")
+            cmake_args.append(f"-DPython3_EXECUTABLE={sys.executable}")
+
     # C++ standard
     if args.cxx_standard is not None:
         cmake_args.append("-DCMAKE_CXX_STANDARD=%s" % args.cxx_standard)
@@ -794,7 +801,7 @@
 
             ns3_program_map[shortcut_path] = [program]
 
-            # Add an additional shortcut with .exe suffix when running on Windows
+            # Add a shortcut with .exe suffix when running on Windows
             if sys.platform == "win32":
                 ns3_program_map[shortcut_path.replace("\\", "/")] = [program]
                 ns3_program_map[shortcut_path + ".exe"] = [program]
@@ -846,6 +853,7 @@
     if not cmake:
         print("Error:  CMake not found; please install version 3.10 or greater, or modify", path_variable)
         exit(1)
+    cmake = cmake.replace(".EXE", "").replace(".exe", "")  # Trim cmake executable extension
     cmake_output = subprocess.check_output([cmake, "--version"]).decode("utf-8")
     version = re.findall("version (.*)", cmake_output)[0]
     if parse_version(version) < parse_version("3.10.0"):
@@ -1045,6 +1053,7 @@
                                   "docs",
                                   "doxygen",
                                   "doxygen-no-build",
+                                  "installation",
                                   "sphinx",
                                   "manual",
                                   "models",
@@ -1063,7 +1072,7 @@
                 target = get_target_to_build(target, ns3_version, build_profile)
             else:
                 # Sphinx target should have the sphinx prefix
-                if target in ["contributing", "manual", "models", "tutorial"]:
+                if target in ["contributing", "installation", "manual", "models", "tutorial"]:
                     target = "sphinx_%s" % target
 
                 # Docs should build both doxygen and sphinx based docs
@@ -1584,30 +1593,7 @@
                    output
                    )
 
-    def remove_overlapping_path(base_path, target_path):
-        """
-        Remove overlapping paths from output directory and target_to_run
-        :param base_path: output path of the ns-3 build
-        :param target_path: path to the executable to run
-        :return: target_path without the overlapping parts
-        """
-        target_path = target_path.replace('/', os.sep).split(os.sep)
-        base_path = base_path.replace('/', os.sep).split(os.sep)
-        while target_path[0] in base_path:
-            target_path = target_path[1:]
-        target_path = os.sep.join(target_path)
-        return target_path
-
     if not args.shell and target_to_run and ".py" not in target_to_run:
-        target_to_run = remove_overlapping_path(out_dir, target_to_run)
-
-        # Waf doesn't add version prefix and build type suffix to the scratches, so we remove them
-        if current_cmake_cache_folder is None:
-            if "scratch" in target_to_run and run_only:
-                waf_target_to_run = target_to_run.replace(os.path.basename(target_to_run), args.run)
-                if os.path.exists(os.sep.join([out_dir, waf_target_to_run])):
-                    target_to_run = waf_target_to_run
-        target_to_run = os.sep.join([out_dir, target_to_run])
         if sys.platform == "win32":
             target_to_run += ".exe"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/pyproject.toml ns-3.39/pyproject.toml
--- ns-3.38/pyproject.toml	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/pyproject.toml	2023-07-05 14:23:47.673426900 -0700
@@ -0,0 +1,16 @@
+[build-system]
+build-backend = "setuptools.build_meta"
+requires = [
+    "wheel",
+    "setuptools>=45",
+    "setuptools_scm[toml]>=6.0",
+    "cmake-build-extension>=0.4",
+    "cppyy==2.4.2",
+]
+
+[tool.setuptools_scm]
+version_scheme = "post-release"
+local_scheme = "no-local-version"
+
+[tool.cibuildwheel]
+build-frontend = "build"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/scratch/CMakeLists.txt ns-3.39/scratch/CMakeLists.txt
--- ns-3.38/scratch/CMakeLists.txt	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/scratch/CMakeLists.txt	2023-07-05 14:23:47.673426900 -0700
@@ -30,7 +30,17 @@
   string(REPLACE "/" "_" scratch_dirname "${scratch_dirname}")
 
   # Get source name
-  get_filename_component(scratch_name ${scratch_src} NAME_WE)
+  if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.14.0")
+    get_filename_component(scratch_name ${scratch_src} NAME_WLE)
+  else()
+    get_filename_component(scratch_name ${scratch_src} NAME)
+    string(FIND "${scratch_name}" "." ext_position REVERSE)
+    if(${ext_position} EQUAL -1)
+      message(FATAL_ERROR "Source file has no extension: ${scratch_src}")
+    else()
+      string(SUBSTRING "${scratch_name}" 0 ${ext_position} scratch_name)
+    endif()
+  endif()
 
   set(target_prefix scratch_)
   if(scratch_dirname)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/setup.cfg ns-3.39/setup.cfg
--- ns-3.38/setup.cfg	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/setup.cfg	2023-07-05 14:23:47.673426900 -0700
@@ -0,0 +1,44 @@
+[metadata]
+name = ns3
+description = ns-3 network simulator and visualizer
+long_description = file: README.md
+long_description_content_type = text/markdown
+author = nsnam
+author_email = webmaster@nsnam.org
+license = GPL-2.0-only
+platforms = any
+url = https://www.nsnam.org/
+
+project_urls =
+    Tracker = https://gitlab.com/nsnam/ns-3-dev/-/issues
+    Documentation = https://www.nsnam.org/docs/tutorial/html/index.html
+    Source = https://gitlab.com/nsnam/ns-3-dev
+
+keywords =
+    network-simulator
+
+classifiers =
+    Development Status :: 5 - Production/Stable
+    Operating System :: POSIX :: Linux
+    #Operating System :: MacOS
+    #Operating System :: Microsoft :: Windows
+    Intended Audience :: Education
+    Intended Audience :: Developers
+    Intended Audience :: Science/Research
+    Programming Language :: C++
+    Programming Language :: Python :: 3.6
+    Programming Language :: Python :: 3.7
+    Programming Language :: Python :: 3.8
+    Programming Language :: Python :: 3.9
+    Programming Language :: Python :: 3.10
+    Programming Language :: Python :: 3.11
+    Programming Language :: Python :: 3 :: Only
+    Programming Language :: Python :: Implementation :: CPython
+    License :: OSI Approved :: GNU General Public License v2 (GPLv2)
+
+[options]
+zip_safe = False
+python_requires = >=3.6
+install_requires =
+    cppyy==2.4.2
+
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/setup.py ns-3.39/setup.py
--- ns-3.38/setup.py	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/setup.py	2023-07-05 14:23:47.673426900 -0700
@@ -0,0 +1,35 @@
+import cmake_build_extension
+import setuptools
+import sys
+import sysconfig
+
+setuptools.setup(
+    cmdclass=dict(build_ext=cmake_build_extension.BuildExtension),
+    packages=['ns', 'visualizer'],
+    package_dir={
+      'ns': './build-support/pip-wheel/ns',
+      'visualizer': './build-support/pip-wheel/visualizer'
+    },
+    ext_modules=[
+        cmake_build_extension.CMakeExtension(
+            name="BuildAndInstall",
+            install_prefix="ns3",
+            cmake_configure_options=[
+                "-DCMAKE_BUILD_TYPE:STRING=release",
+                "-DNS3_ASSERT:BOOL=ON",
+                "-DNS3_LOG:BOOL=ON",
+                "-DNS3_WARNINGS_AS_ERRORS:BOOL=OFF",
+                "-DNS3_PYTHON_BINDINGS:BOOL=ON",
+                "-DNS3_BINDINGS_INSTALL_DIR:STRING=INSTALL_PREFIX",
+                "-DNS3_FETCH_OPTIONAL_COMPONENTS:BOOL=ON",
+                "-DNS3_PIP_PACKAGING:BOOL=ON",
+                "-DNS3_USE_LIB64:BOOL=ON",
+                # Make CMake find python components from the currently running python
+                # https://catherineh.github.io/programming/2021/11/16/python-binary-distributions-whls-with-c17-cmake-auditwheel-and-manylinux
+                f"-DPython3_LIBRARY_DIRS={sysconfig.get_config_var('LIBDIR')}",
+                f"-DPython3_INCLUDE_DIRS={sysconfig.get_config_var('INCLUDEPY')}",
+                f"-DPython3_EXECUTABLE={sys.executable}"
+            ]
+        ),
+    ],
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/antenna/model/phased-array-model.h ns-3.39/src/antenna/model/phased-array-model.h
--- ns-3.38/src/antenna/model/phased-array-model.h	2023-03-16 20:54:23.576868300 -0700
+++ ns-3.39/src/antenna/model/phased-array-model.h	2023-07-05 14:23:47.673426900 -0700
@@ -140,13 +140,6 @@
     uint32_t GetId() const;
 
   protected:
-    /**
-     * Utility method to compute the euclidean norm of a ComplexVector
-     * \param vector the ComplexVector
-     * \return the euclidean norm
-     */
-    static double ComputeNorm(const ComplexVector& vector);
-
     ComplexVector m_beamformingVector;  //!< the beamforming vector in use
     Ptr<AntennaModel> m_antennaElement; //!< the model of the antenna element in use
     bool m_isBfVectorValid;             //!< ensures the validity of the beamforming vector
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/aodv/model/aodv-id-cache.h ns-3.39/src/aodv/model/aodv-id-cache.h
--- ns-3.38/src/aodv/model/aodv-id-cache.h	2023-03-16 20:54:23.576868300 -0700
+++ ns-3.39/src/aodv/model/aodv-id-cache.h	2023-07-05 14:23:47.673426900 -0700
@@ -109,7 +109,7 @@
          * \param u UniqueId entry
          * \return true if expired, false otherwise
          */
-        bool operator()(const struct UniqueId& u) const
+        bool operator()(const UniqueId& u) const
         {
             return (u.m_expire < Simulator::Now());
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/aodv/model/aodv-routing-protocol.cc ns-3.39/src/aodv/model/aodv-routing-protocol.cc
--- ns-3.38/src/aodv/model/aodv-routing-protocol.cc	2023-03-16 20:54:23.576868300 -0700
+++ ns-3.39/src/aodv/model/aodv-routing-protocol.cc	2023-07-05 14:23:47.673426900 -0700
@@ -497,10 +497,10 @@
 RoutingProtocol::RouteInput(Ptr<const Packet> p,
                             const Ipv4Header& header,
                             Ptr<const NetDevice> idev,
-                            UnicastForwardCallback ucb,
-                            MulticastForwardCallback mcb,
-                            LocalDeliverCallback lcb,
-                            ErrorCallback ecb)
+                            const UnicastForwardCallback& ucb,
+                            const MulticastForwardCallback& mcb,
+                            const LocalDeliverCallback& lcb,
+                            const ErrorCallback& ecb)
 {
     NS_LOG_FUNCTION(this << p->GetUid() << header.GetDestination() << idev->GetAddress());
     if (m_socketAddresses.empty())
@@ -558,7 +558,7 @@
                 }
                 UpdateRouteLifeTime(origin, m_activeRouteTimeout);
                 Ptr<Packet> packet = p->Copy();
-                if (lcb.IsNull() == false)
+                if (!lcb.IsNull())
                 {
                     NS_LOG_LOGIC("Broadcast local delivery to " << iface.GetLocal());
                     lcb(p, header, iif);
@@ -617,7 +617,7 @@
             UpdateRouteLifeTime(toOrigin.GetNextHop(), m_activeRouteTimeout);
             m_nb.Update(toOrigin.GetNextHop(), m_activeRouteTimeout);
         }
-        if (lcb.IsNull() == false)
+        if (!lcb.IsNull())
         {
             NS_LOG_LOGIC("Unicast local delivery to " << dst);
             lcb(p, header, iif);
@@ -632,7 +632,7 @@
     }
 
     // Check if input device supports IP forwarding
-    if (m_ipv4->IsForwarding(iif) == false)
+    if (!m_ipv4->IsForwarding(iif))
     {
         NS_LOG_LOGIC("Forwarding disabled for this interface");
         ecb(p, header, Socket::ERROR_NOROUTETOHOST);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/aodv/model/aodv-routing-protocol.h ns-3.39/src/aodv/model/aodv-routing-protocol.h
--- ns-3.38/src/aodv/model/aodv-routing-protocol.h	2023-03-16 20:54:23.576868300 -0700
+++ ns-3.39/src/aodv/model/aodv-routing-protocol.h	2023-07-05 14:23:47.673426900 -0700
@@ -78,10 +78,10 @@
     bool RouteInput(Ptr<const Packet> p,
                     const Ipv4Header& header,
                     Ptr<const NetDevice> idev,
-                    UnicastForwardCallback ucb,
-                    MulticastForwardCallback mcb,
-                    LocalDeliverCallback lcb,
-                    ErrorCallback ecb) override;
+                    const UnicastForwardCallback& ucb,
+                    const MulticastForwardCallback& mcb,
+                    const LocalDeliverCallback& lcb,
+                    const ErrorCallback& ecb) override;
     void NotifyInterfaceUp(uint32_t interface) override;
     void NotifyInterfaceDown(uint32_t interface) override;
     void NotifyAddAddress(uint32_t interface, Ipv4InterfaceAddress address) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/aodv/model/aodv-rtable.h ns-3.39/src/aodv/model/aodv-rtable.h
--- ns-3.38/src/aodv/model/aodv-rtable.h	2023-03-16 20:54:23.576868300 -0700
+++ ns-3.39/src/aodv/model/aodv-rtable.h	2023-07-05 14:23:47.673426900 -0700
@@ -407,7 +407,7 @@
     /// List of precursors
     std::vector<Ipv4Address> m_precursorList;
     /// When I can send another request
-    Time m_routeRequestTimout;
+    Time m_routeRequestTimeout;
     /// Number of route requests
     uint8_t m_reqCount;
     /// Indicate if this entry is in "blacklist"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/aodv/test/examples-to-run.py ns-3.39/src/aodv/test/examples-to-run.py
--- ns-3.38/src/aodv/test/examples-to-run.py	2023-03-16 20:54:23.576868300 -0700
+++ ns-3.39/src/aodv/test/examples-to-run.py	2023-07-05 14:23:47.673426900 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/applications/examples/three-gpp-http-example.cc ns-3.39/src/applications/examples/three-gpp-http-example.cc
--- ns-3.38/src/applications/examples/three-gpp-http-example.cc	2023-03-16 20:54:23.576868300 -0700
+++ ns-3.39/src/applications/examples/three-gpp-http-example.cc	2023-07-05 14:23:47.677426800 -0700
@@ -93,6 +93,17 @@
     }
 }
 
+void
+ClientPageReceived(Ptr<const ThreeGppHttpClient> client,
+                   const Time& time,
+                   uint32_t numObjects,
+                   uint32_t numBytes)
+{
+    NS_LOG_INFO("Client " << client << " has received a page that took " << time.As(Time::MS)
+                          << " ms to load with " << numObjects << " objects and " << numBytes
+                          << " bytes.");
+}
+
 int
 main(int argc, char* argv[])
 {
@@ -163,6 +174,7 @@
     httpClient->TraceConnectWithoutContext("RxEmbeddedObject",
                                            MakeCallback(&ClientEmbeddedObjectReceived));
     httpClient->TraceConnectWithoutContext("Rx", MakeCallback(&ClientRx));
+    httpClient->TraceConnectWithoutContext("RxPage", MakeCallback(&ClientPageReceived));
 
     // Stop browsing after 30 minutes
     clientApps.Stop(Seconds(simTimeSec));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/applications/model/three-gpp-http-client.cc ns-3.39/src/applications/model/three-gpp-http-client.cc
--- ns-3.38/src/applications/model/three-gpp-http-client.cc	2023-03-16 20:54:23.580868500 -0700
+++ ns-3.39/src/applications/model/three-gpp-http-client.cc	2023-07-05 14:23:47.705427000 -0700
@@ -47,6 +47,9 @@
       m_objectClientTs(MilliSeconds(0)),
       m_objectServerTs(MilliSeconds(0)),
       m_embeddedObjectsToBeRequested(0),
+      m_pageLoadStartTs(MilliSeconds(0)),
+      m_numberEmbeddedObjectsRequested(0),
+      m_numberBytesPage(0),
       m_httpVariables(CreateObject<ThreeGppHttpVariables>())
 {
     NS_LOG_FUNCTION(this);
@@ -76,6 +79,10 @@
                           UintegerValue(80), // the default HTTP port
                           MakeUintegerAccessor(&ThreeGppHttpClient::m_remoteServerPort),
                           MakeUintegerChecker<uint16_t>())
+            .AddTraceSource("RxPage",
+                            "A page has been received.",
+                            MakeTraceSourceAccessor(&ThreeGppHttpClient::m_rxPageTrace),
+                            "ns3::ThreeGppHttpClient::RxPageTracedCallback")
             .AddTraceSource(
                 "ConnectionEstablished",
                 "Connection to the destination web server has been established.",
@@ -162,29 +169,21 @@
     {
     case NOT_STARTED:
         return "NOT_STARTED";
-        break;
     case CONNECTING:
         return "CONNECTING";
-        break;
     case EXPECTING_MAIN_OBJECT:
         return "EXPECTING_MAIN_OBJECT";
-        break;
     case PARSING_MAIN_OBJECT:
         return "PARSING_MAIN_OBJECT";
-        break;
     case EXPECTING_EMBEDDED_OBJECT:
         return "EXPECTING_EMBEDDED_OBJECT";
-        break;
     case READING:
         return "READING";
-        break;
     case STOPPED:
         return "STOPPED";
-        break;
     default:
         NS_FATAL_ERROR("Unknown state");
         return "FATAL_ERROR";
-        break;
     }
 }
 
@@ -447,6 +446,7 @@
         else
         {
             SwitchToState(EXPECTING_MAIN_OBJECT);
+            m_pageLoadStartTs = Simulator::Now(); // start counting page loading time
         }
     }
     else
@@ -628,6 +628,7 @@
                  * downloaded completely. Now is the time to read it.
                  */
                 NS_LOG_INFO(this << " Finished receiving a web page.");
+                FinishReceivingPage(); // trigger callback for page loading time
                 EnterReadingTime();
             }
 
@@ -669,6 +670,7 @@
         m_constructedPacket->AddHeader(httpHeader);
     }
     uint32_t contentSize = packet->GetSize();
+    m_numberBytesPage += contentSize; // increment counter of page size
 
     /* Note that the packet does not contain header at this point.
      * The content is purely raw data, which was the only intended data to be received.
@@ -724,6 +726,8 @@
     if (m_state == PARSING_MAIN_OBJECT)
     {
         m_embeddedObjectsToBeRequested = m_httpVariables->GetNumOfEmbeddedObjects();
+        // saving total number of embedded objects
+        m_numberEmbeddedObjectsRequested = m_embeddedObjectsToBeRequested;
         NS_LOG_INFO(this << " Parsing has determined " << m_embeddedObjectsToBeRequested
                          << " embedded object(s) in the main object.");
 
@@ -743,6 +747,7 @@
              * enjoy the plain web page.
              */
             NS_LOG_INFO(this << " Finished receiving a web page.");
+            FinishReceivingPage(); // trigger callback for page loading time
             EnterReadingTime();
         }
     }
@@ -826,4 +831,16 @@
     m_stateTransitionTrace(oldState, newState);
 }
 
+void
+ThreeGppHttpClient::FinishReceivingPage()
+{
+    m_rxPageTrace(this,
+                  Simulator::Now() - m_pageLoadStartTs,
+                  m_numberEmbeddedObjectsRequested,
+                  m_numberBytesPage);
+    // Reset counter variables.
+    m_numberEmbeddedObjectsRequested = 0;
+    m_numberBytesPage = 0;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/applications/model/three-gpp-http-client.h ns-3.39/src/applications/model/three-gpp-http-client.h
--- ns-3.38/src/applications/model/three-gpp-http-client.h	2023-03-16 20:54:23.580868500 -0700
+++ ns-3.39/src/applications/model/three-gpp-http-client.h	2023-07-05 14:23:47.705427000 -0700
@@ -172,6 +172,20 @@
      */
     typedef void (*TracedCallback)(Ptr<const ThreeGppHttpClient> httpClient);
 
+    /**
+     * Callback signature for `RxPage` trace sources.
+     * \param httpClient Pointer to this instance of ThreeGppHttpClient,
+     *                               which is where the trace originated.
+     * \param time Elapsed time from the start to the end of the request.
+     * \param numObjects Number of objects downloaded, including main and
+     *                                                  embedded objects.
+     * \param numBytes Total number of bytes included in the page.
+     */
+    typedef void (*RxPageTracedCallback)(Ptr<const ThreeGppHttpClient> httpClient,
+                                         const Time& time,
+                                         uint32_t numObjects,
+                                         uint32_t numBytes);
+
   protected:
     // Inherited from Object base class.
     void DoDispose() override;
@@ -343,6 +357,12 @@
      */
     void SwitchToState(State_t state);
 
+    /**
+     * Finish receiving a page. This function should be called when a full-page
+     * finishes loading, including the main object and all embedded objects.
+     */
+    void FinishReceivingPage();
+
     /// The current state of the client application. Begins with NOT_STARTED.
     State_t m_state;
     /// The socket for sending and receiving packets to/from the web server.
@@ -357,6 +377,12 @@
     Time m_objectServerTs;
     /// Determined after parsing the main object.
     uint32_t m_embeddedObjectsToBeRequested;
+    /// The time stamp when the page started loading.
+    Time m_pageLoadStartTs;
+    /// Number of embedded objects to requested in the current page.
+    uint32_t m_numberEmbeddedObjectsRequested;
+    /// Number of bytes received for the current page.
+    uint32_t m_numberBytesPage;
 
     // ATTRIBUTES
 
@@ -369,6 +395,9 @@
 
     // TRACE SOURCES
 
+    /// The `RxPage` trace source.
+    ns3::TracedCallback<Ptr<const ThreeGppHttpClient>, const Time&, uint32_t, uint32_t>
+        m_rxPageTrace;
     /// The `ConnectionEstablished` trace source.
     ns3::TracedCallback<Ptr<const ThreeGppHttpClient>> m_connectionEstablishedTrace;
     /// The `ConnectionClosed` trace source.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/applications/model/three-gpp-http-server.cc ns-3.39/src/applications/model/three-gpp-http-server.cc
--- ns-3.38/src/applications/model/three-gpp-http-server.cc	2023-03-16 20:54:23.580868500 -0700
+++ ns-3.39/src/applications/model/three-gpp-http-server.cc	2023-07-05 14:23:47.705427000 -0700
@@ -155,17 +155,13 @@
     {
     case NOT_STARTED:
         return "NOT_STARTED";
-        break;
     case STARTED:
         return "STARTED";
-        break;
     case STOPPED:
         return "STOPPED";
-        break;
     default:
         NS_FATAL_ERROR("Unknown state");
         return "FATAL_ERROR";
-        break;
     }
 }
 
@@ -197,7 +193,7 @@
             const TypeId tcpSocketTid = TcpSocket::GetTypeId();
             for (uint32_t i = 0; i < tcpSocketTid.GetAttributeN(); i++)
             {
-                struct TypeId::AttributeInformation attrInfo = tcpSocketTid.GetAttribute(i);
+                TypeId::AttributeInformation attrInfo = tcpSocketTid.GetAttribute(i);
                 if (attrInfo.name == "SegmentSize")
                 {
                     previousSocketMtu = attrInfo.initialValue;
